# M2产品使用文档

## 一、维护说明

classis 底盘相关文档

classis/imgs 底盘相关图片

navigationKit 套件相关文档

navigationKit/imgs 套件相关图片

package 驱动包，文档中暂无引用（维护人:邱鹏）

conf.json 官网文档目录配置

## 二、视频播放

### 1. 整理视频格式

将视频格式统一为mp4

尽可能长宽比为16:9,建议统一为1920x1080

建议文件名为英文小写用减号连接,例: xxx-xx-xxx.mp4

编解码器:MPEG-4 AAC、H.264 (可在右键简介中验证)

颜色描述文件:HD (1-1-1) (可在右键简介中验证)

### 2. 压缩视频体积

安装ffmpeg (一次性操作)

```sShell
brew install ffmpeg
```

将压缩脚本放入视频目录,**zipmp4.sh**源码如下

```Shell
for f in "$@"
do
    if [[ "${f##*.}" == "mp4" ]]; then
	ffmpeg -i "$f" -c:v libx264 -c:a aac -strict experimental -profile:v high -pix_fmt yuv420p -movflags +faststart "${f%.*}.tmp.mp4"
        mv "$f" "${f%.*}.bak.mp4"
        mv "${f%.*}.tmp.mp4" "$f"
    fi
done
```

执行脚本

```Shell
./zipmp4.sh ./*
```

检测视频是否损坏失真变色等

### 3. 上传视频

使用腾讯的 **COSBrowser** 上视频文件传到 **video-autolabor-1255388470** 存储桶中

如果是已有视频进行更新，需要从云存储获取播放地址，登录腾讯云进行CDN缓存刷新

自定义播放域名是 http://video.autolabor.com.cn/

加上视频文件在存储桶内的相对地址，可得到官网和文档使用的播放地址

### 4. 使用html5播放器

> 直接播放一个视频网址时使用

```HTML

<video width="860" height="485" controls>
    <source src="http://video.autolabor.com.cn/xx/xx-xx-xxx.mp4" type="video/mp4">
    您的浏览器不支持 video 标签。
</video>
```

### 5. 使用教程播放器

> 播放指定官网教程时使用

```HTML

<iframe src="http://www.autolabor.com.cn/lib/video/docplay/xx" frameborder="0" width="640" height="360"
        allowfullscreen></iframe>
```

## 三、上线文档

### 1. 上传仓库

提交到git仓库，建议耐心填写提交信息

使用jetbrains系列编辑器(例如:Writerside)时，建议使用 **CommitMessage** 插件规范提交信息

### 2. 更新预览

进入OA官网产品文档管理页

刷新页面，git有更新的文档 **仓库列** 会出现 **同步** 按钮

先同步，再更新预览，通过 **操作列** 的 **预览** 查看文档内容和显示效果是否达到预期

循环 **修改文档**，**提交git**，**OA同步**，**更新预览** 的操作直到预览环境的效果达到预期

### 3. 官网上线

执行 **官网文档列** 的 **官网上线**

点击 **操作列** 的 **官网** 查看上线效果
