## 键盘控制节点

该包提供了一个键盘控制节点，可以将键盘输入转换为 `geometry_msgs/Twist` 消息，从而通过键盘控制机器人的速度。

### 特性

- **控制命令**：该节点将特定的键盘按键转换为线速度和角速度命令。
- **动态缩放**：允许使用指定的键动态缩放线速度和角速度。
- **切换发送标志**：可以使用特定的键切换发送速度命令的开/关状态。

### 安装

1. 将该存储库克隆到您的 catkin 工作空间中：

   ```bash
   git clone <repository_url> <catkin_workspace>/src/keyboard_control
   ```

2. 构建该包：

   ```bash
    cd <catkin_workspace>
    catkin build --this
    ```

### 使用方法

1. 运行键盘控制节点：

   ```bash
   roslaunch keyboard_control keyboard_control.launch
   ```

2. 在终端中按下以下键盘按键来控制机器人：

    - **上箭头键**：增加线速度。
    - **下箭头键**：减少线速度。
    - **左箭头键**：增加角速度。
    - **右箭头键**：减少角速度。
    - **数字键1**：增加线速度缩放。
    - **数字键2**：减少线速度缩放。
    - **数字键3**：增加角速度缩放。
    - **数字键4**：减少角速度缩放。
    - **数字键9**：启用发送速度命令。
    - **数字键0**：禁用发送速度命令。

### 参数设置

您可以通过编辑 `keyboard_control.launch` 文件来调整参数，包括线速度和角速度的最小值、最大值、步长以及发送速度命令的频率。

### 节点信息

- **发布的话题**:
    - `/cmd_vel` (`geometry_msgs/Twist`)：发布机器人的速度命令。

- **订阅的话题**:
    - 无。

### 依赖项

- ROS (Robot Operating System)
- Boost C++ 库

### 注意事项

- 在运行节点之前，请确保键盘已连接到计算机上。
- 该节点仅适用于Linux系统。
- 使用键盘控制节点时，请小心操作，避免发生意外。

### 作者

该键盘控制节点由 autolabor 官方开发。

### 协议

该软件遵循 [MIT License](LICENSE)。

### 联系我们

如有任何问题或建议，请联系我们。

### 贡献

欢迎贡献代码和提出改进建议。请提交 issue 或 pull request。

### 版权声明

版权所有 © 2024 autolabor_tool。